<?php
/**
* @version		Roket Virtue Mart Discount Real
* @package		Module mod_roketVMdiscount.zip
* @copyright	Copyright (C) 2012 Roket007
* @license		GNU/GPL, http://roket.kiev.ua
*/

if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' ); 
global $mosConfig_absolute_path;

if( file_exists(dirname(__FILE__).'/../../components/com_virtuemart/virtuemart_parser.php' )) {
	require_once( dirname(__FILE__).'/../../components/com_virtuemart/virtuemart_parser.php' );
} else {
	require_once( dirname(__FILE__).'/../components/com_virtuemart/virtuemart_parser.php' );
}

require_once(CLASSPATH.'ps_product.php');
require_once(CLASSPATH.'ps_session.php');
require_once(CLASSPATH.'ps_product_category.php');
require_once( CLASSPATH . 'ps_product_attribute.php');
JHTML::_('behavior.modal'); 
$ps_product_category = new ps_product_category;
$ps_product = new ps_product;
$ps_session = new vm_ps_session;
$ps_product_attribute = new ps_product_attribute;
$db = new ps_DB;
if(empty($cat_part))
{
	if($type_show == "rand")
	{
		$sql_part = "RAND()";
	}
	else
	{
		$sql_part = "cdate DESC";
	}
	
	$q  = "
		SELECT product_id, product_parent_id, product_thumb_image, product_s_desc, product_name, product_publish 
		FROM #__{vm}_product 
		WHERE product_discount_id > 0 AND product_publish = 'Y'
		ORDER BY ".$sql_part." 
		LIMIT ".$max_items;
	$db->query($q);
	
	$i=0;
	$img = '';
	$rand_prods = '';
	$name = '';
	while($db->next_record()){
		if($db->f("product_publish") == "Y")
		{
			$rand_prods[$i] = $db->f("product_id");
			$img[$i] = $db->f("product_thumb_image");
			$name[$i] = $db->f("product_name");
			$desc[$i] = $db->f("product_s_desc");
			$i++;
		}
	}
	
	if($type_prod) {
		$parameters = makeParams($rand_prods);
	}
}
else
{
	if($type_show == "rand")
	{
		$sql_part = "RAND()";
	}
	else
	{
		$sql_part = "#__{vm}_product.cdate DESC";
	}
	$categories_ids = explode(",",$cat_part);
	if(count($categories_ids) == 1)
	{
		$category_id = $categories_ids[0];
		$q  = "SELECT DISTINCT product_sku, #__{vm}_product.product_id, #__{vm}_product.product_thumb_image, #__{vm}_product.product_name, product_s_desc ";
		$q .= "FROM #__{vm}_product, #__{vm}_product_category_xref, #__{vm}_category WHERE  ";
		$q .= "#__{vm}_product.product_id=#__{vm}_product_category_xref.product_id ";
		$q .= "AND #__{vm}_category.category_id=#__{vm}_product_category_xref.category_id ";
		$q .= "AND #__{vm}_category.category_id='$category_id' ";
		$q .= "AND #__{vm}_product.product_publish='Y' ";
		$q .= "AND product_discount_id > 0 ";
		$q .= "ORDER BY ".$sql_part." LIMIT ".$max_items;
	}
	$db->query($q);
	$i=0;
	while($db->next_record())
	{
			$rand_prods[$i] = $db->f("product_id");
			$img[$i] = $db->f("product_thumb_image");
			$name[$i] = $db->f("product_name");
			$desc[$i] = $db->f("product_s_desc");
			$i++;
	}
	
	if($type_prod) {
		$parameters = makeParams($rand_prods);
	}
	
}

function makeParams($prod_ids = array()) {
	if(!empty($prod_ids) && count($prod_ids) > 0) {
		$dbs = JFactory::getDBO();
		$query = "
            SELECT pptx.product_type_id AS type_id, pptx.product_id AS prod_id
            FROM #__vm_product_product_type_xref AS pptx 
            WHERE pptx.product_id IN (" . implode(',', $prod_ids) . ")
		";
		$dbs->setQuery($query);
		if(!$dbs->query()) {
			JError::raiseError( 500, $dbs->stderr());
		} else {
			$reuslt_type = $dbs->loadObjectList();
			$end = array();
			if(!empty($reuslt_type)) {
				foreach($reuslt_type as $res) {
					if(!in_array($res->type_id, $end)) {
						$end[] = $res->type_id;
					}
				}
				
			} else {
				$end = false;
			}
            if(!empty($end)) {
    			$query = "
    				SELECT ptp.product_type_id AS p_type, ptp.parameter_label AS p_name, ptp.parameter_name AS param, ptp.parameter_unit AS p_value, ptp.parameter_list_order AS p_ord
    				FROM #__vm_product_type_parameter AS ptp
    				WHERE ptp.product_type_id IN (" . implode(',', $end) . ")
    			";
    			$dbs->setQuery($query);
    			if(!$dbs->query()) {
    				JError::raiseError( 500, $dbs->stderr());
    			} else {
                    $left_join = '';
                    $new_array = array();
    				$param_type_result = $dbs->loadObjectList();
    				if(!empty($param_type_result)) {
    					foreach($prod_ids as $per_prod_id) {
    						$new_array[$per_prod_id] = array();
    						foreach($reuslt_type as $type_per) {
    							if($per_prod_id == $type_per->prod_id) {
    								foreach($param_type_result as $per_param_type_prod) {
    									if($type_per->type_id == $per_param_type_prod->p_type) {
											$query = "SELECT " . $per_param_type_prod->param . " FROM #__vm_product_type_" . $per_param_type_prod->p_type . " WHERE product_id = " . $per_prod_id;
											$dbs->setQuery($query);
											if(!$dbs->query()) {
											} else {
												$value = $dbs->loadResult();
												$new_array[$per_prod_id][$per_param_type_prod->p_ord] = array('name' => $per_param_type_prod->p_name, 'value' => $value, 'unit' => $per_param_type_prod->p_value);
											}
										}
    								}
    							}
    						}
    					}
    					
    					return $new_array;
    					
    				} else {
    					return false;
    				}
    			}
            } else {
                return false;
            }	
		}
	} else {
		return false;
	}
	return false;
}

function makeParamHTML($data, $width_block) {
	if( !empty($data) ) {
		ksort($data);
		$html = '<div style="clear:both;"></div>';
		$html .= '<table class="' . $pack_class . 'table-type" width="' . $width_block . '">';
		foreach($data as $parameter) {
			$html .= '<tr>';
				$html .= '<td width="50%" align="left">' 
						. ((substr($parameter['name'], -1) == ':') ? $parameter['name'] : $parameter['name'] . ':' ) 
						. '</td><td>' . $parameter['value'] 
						. ' ' 
						. ( !empty($parameter['unit']) ? $parameter['unit'] : '' ) 
						. '</td>';
			$html .= '</tr>';
		}
		$html .= '</table>';
		$html .= '<div style="clear:both;"></div>';
		return $html;
	} else {
		return false;
	}	
}

function ajaxAddCart($id,$ps_product,$qountity_show,$show_addtocart,$ps_product_attribute,$ajax)
{
	if($show_addtocart)
	{
		if($qountity_show)
		{
			$options_add = '
			<label class="quantity_box" for="quantity'.$id.'">Quantity:&nbsp;
			<input id="quantity_module'.$id.'" class="inputboxquantity" type="text" value="1" name="quantity[]" size="4" />
			<input class="quantity_box_button quantity_box_button_up" type="button" onclick="var qty_el = document.getElementById(\'quantity_module'.$id.'\'); var qty = qty_el.value; if( !isNaN( qty )) qty_el.value++;return false;" />
			<input class="quantity_box_button quantity_box_button_down" type="button" onclick="var qty_el = document.getElementById(\'quantity_module'.$id.'\'); var qty = qty_el.value; if( !isNaN( qty ) && qty > 0 ) qty_el.value--;return false;" /></label>			
			';
		}
		else
		{
			$options_add = "";
		}
		return $options_add;
	}
}

function showMan($id,$ps_product)
{
	$man_add = $ps_product->get_mf_name($id);
	return $man_add;
}

function getImg($img,$ps_product,$class,$width)
{
	$img_send = $ps_product->image_tag($img, "align=\"center\" class=\"img_".$class."\"");
	$dropper = array("/width=[\"|'][\d]*[\"|']/Ui","/height=[\"|'][\d]*[\"|']/Ui");
	$replacer = array("/width=\"".$width."\"","");
	if(preg_match($dropper[0],$img_send))
	{
		$img_send = preg_replace($dropper[0],$replacer[0],$img_send);
	}
	else
	{
		$img_send = preg_replace("/<img/Ui","<img width=\"".$width."\" ",$img_send);
	}
	if(preg_match($dropper[1],$img_send))
	{
		$img_send = preg_replace($dropper[1],$replacer[1],$img_send);
	}
	return $img_send;
}

function getProdUrl($id,$ps_product,$prod_cat_get)
{
	global $sess, $mm_action_url;
	$cid = $prod_cat_get->get_cid($id);
	$url = "?page=shop.product_details&category_id=".$cid."&flypage=".$ps_product->get_flypage($id);
	$url .= "&product_id=".$id;
	$url_raw_view = $sess->url($mm_action_url. "index.php" . $url);
	return $url_raw_view;
}

function showPrices($id,$ps_product)
{
	$price_add = $ps_product->show_price($id);
	return $price_add;
}

function showName($name_s,$url,$type,$class)
{
	if($type)
	{
		$name = "<a href=\"".$url."\" class=\"link_name".$class."\">";
		$name .= $name_s;
		$name .= "</a>";
	}
	else
	{
		$name = $name_s;
	}
	return $name;
}

function showImages($img,$url,$type,$class)
{
	if($type)
	{
		$image = "<a href=\"".$url."\" class=\"link_name".$class."\">";
		$image .= $img;
		$image .= "</a>";
	}
	else
	{
		$image = $img;
	}
	return $image;
}

function startForm($ajax,$classes,$show_addtocart)
{
	if($show_addtocart)
	{
		global $sess, $mm_action_url;
		$add = '<form class="form_add_'.$classes.'" action="'.$mm_action_url.'index.php" method="post" name="addtocart" id="'.uniqid("addtocart_").'"';
		if($ajax)
		{
			$add .= 'onSubmit="handleAddToCart( this.id );return false;">';
		}
		else
		{
			$add .= '>';
		}
		return $add;
	}
	
}

function showAttrb($id,$ps_product_attribute,$ajax,$display_attrib,$show_addtocart)
{
	if($show_addtocart)
	{
		if($ajax && $display_attrib)
		{
			list($html, ) = $ps_product_attribute->list_attribute($id);
		}
		elseif($ajax && !$display_attrib)
		{
			$html='
			<input type="hidden" value="'.$id.'" name="product_id">
			';
		}
		elseif(!$ajax && !$display_attrib)
		{
			$html='
			<input type="hidden" value="'.$id.'" name="product_id">
			';
		}
		elseif(!$ajax && $display_attrib)
		{
			list($html, ) = $ps_product_attribute->list_attribute($id);
		}
		return $html.'<br style="clear: both;">';
	}
}

function doCartForm($id,$ps_session,$classes,$submit_text,$show_addtocart,$qountity_show)
{
	if($show_addtocart)
	{
		
		global $sess, $mm_action_url;
		$add = '<input type="submit" class="submit'.$classes.'" value="'.$submit_text.'" title="ADD" />';
		$add .= '
		<input type="hidden" name="option" value="com_virtuemart" />
		<input type="hidden" name="page" value="shop.cart" />
		<input type="hidden" name="Itemid" value="'.$ps_session->getShopItemid().'" />
		<input type="hidden" name="func" value="cartAdd" />
		<input type="hidden" name="prod_id" value="'.$id.'" />
		<input type="hidden" name="product_id" value="'.$id.'" />'.
		(!$qountity_show?'<input type="hidden" name="quantity" value="1" />':'')
		.'<input type="hidden" name="set_price[]" value="" />
		<input type="hidden" name="adjust_price[]" value="" />
		<input type="hidden" name="master_product[]" value="" />
		</form>';
		return $add;
	}
	
}





?>
